"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var color_1 = __importDefault(require("color"));
var React = __importStar(require("react"));
var styled_components_1 = __importDefault(require("styled-components"));
var asRendition_1 = __importDefault(require("../../asRendition"));
var Txt_1 = __importDefault(require("../Txt"));
var shades = [
    '#B3D2E5',
    '#BAECC2',
    '#FDC7EB',
    '#E5C7EA',
    '#BCE6F5',
    '#FCB9B6',
    '#B6E3DF',
    '#D6D3FA',
    '#C3C7CA',
    '#FBDBB2',
    '#E1E3B9',
    '#DBE0E3',
    '#ffef62',
    '#fbe6f4',
];
var getColors = function (shade) {
    var base = new color_1.default(shade);
    var text = base.darken(0.6).desaturate(0.3);
    return { bg: base.hex(), color: text.hex() };
};
var BaseBadge = styled_components_1.default(Txt_1.default.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 1em;\n\tline-height: 1;\n"], ["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 1em;\n\tline-height: 1;\n"])), function (props) { return props.theme.titleFont; });
var Badge = function (_a) {
    var children = _a.children, className = _a.className, shade = _a.shade;
    if (typeof children !== 'string') {
        throw new Error("The child element of the Badge component must be a string, received: " + typeof children);
    }
    var shadeHex = shades[(shade || 0) % shades.length];
    return (React.createElement(BaseBadge, __assign({ className: className, py: 1, px: "12px", fontSize: 0 }, getColors(shadeHex)), children));
};
exports.default = asRendition_1.default(Badge);
var templateObject_1;
