import { JSONSchema6 } from 'json-schema';
import * as React from 'react';
import { FiltersView, ViewScope } from '.';
declare class FilterSummary extends React.Component<FilterSummaryProps, FilterSummaryState> {
    constructor(props: FilterSummaryProps);
    save: (event?: React.FormEvent<HTMLFormElement> | undefined) => void;
    handleChange(e: React.ChangeEvent<HTMLInputElement>): void;
    render(): JSX.Element;
}
export interface FilterSummaryProps {
    edit: (rule: JSONSchema6) => void;
    delete: (rule: JSONSchema6) => void;
    saveView: (name: string, scope: string | null) => void;
    clearAllFilters: () => void;
    filters: JSONSchema6[];
    views: FiltersView[];
    scopes?: ViewScope[];
    schema: JSONSchema6;
}
export interface FilterSummaryState {
    name: string;
    showForm: boolean;
    id: string;
    scope: string | null;
}
export default FilterSummary;
