export declare const breakpoints: number[];
export declare const space: number[];
export declare const fontSizes: number[];
export declare const weights: number[];
export declare const radius = 3;
export declare const font = "'Nunito', Arial, sans-serif";
export declare const titleFont = "CircularStd, Arial, sans-serif";
export declare const monospace = "'Ubuntu Mono', 'Courier New', monospace";
export declare const lineHeight = 1.5;
declare const _default: {
    breakpoints: number[];
    space: number[];
    fontSizes: number[];
    weights: number[];
    font: string;
    titleFont: string;
    monospace: string;
    lineHeight: number;
    colors: {
        primary: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        secondary: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        tertiary: {
            main: string;
            light: string;
            semilight: string;
            dark: string;
        };
        quartenary: {
            main: string;
            light: string;
            dark: string;
        };
        danger: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        warning: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        success: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        info: {
            main: string;
            semilight: string;
            light: string;
            dark: string;
        };
        text: {
            main: string;
            light: string;
            dark: string;
        };
        statusIdle: {
            main: string;
        };
        statusConfiguring: {
            main: string;
        };
        statusUpdating: {
            main: string;
        };
        statusPostProvisioning: {
            main: string;
        };
        statusOffline: {
            main: string;
        };
        statusInactive: {
            main: string;
        };
        gray: {
            main: string;
            light: string;
            dark: string;
        };
    };
    radius: number;
    global: {
        font: {
            family: string;
            size: string;
            height: number;
        };
        control: {
            disabled: {
                opacity: number;
            };
            border: {
                radius: string;
                color: string;
            };
        };
        colors: {
            focus: string;
            placeholder: string;
        };
        selected: {
            background: string;
        };
        hover: {
            background: {
                color: string;
                opacity: number;
            };
            color: {
                dark: string;
                light: string;
            };
        };
        active: {
            background: {
                color: string;
                opacity: number;
            };
            color: {
                dark: string;
                light: string;
            };
        };
        drop: {
            border: {
                radius: string;
            };
            zIndex: number;
            extend: string;
        };
        input: {
            weight: number;
        };
    };
    button: {
        height: string;
        font: {
            weight: number;
        };
        border: {
            width: string;
            radius: string;
            color: string;
        };
        padding: {
            horizontal: string;
        };
    };
    radioButton: {
        border: {
            width: string;
            color: {
                dark: string;
                light: string;
            };
        };
        hover: {
            border: {
                color: {
                    dark: string;
                    light: string;
                };
            };
        };
        check: {
            color: {
                dark: string;
                light: string;
            };
        };
        icon: {
            size: string;
        };
        gap: string;
        size: string;
    };
    select: {
        icons: {
            color: string;
        };
        control: {
            extend: string;
        };
    };
    layer: {
        container: {
            zIndex: number;
        };
        zIndex: number;
    };
    text: {
        medium: {
            size: string;
            height: number;
        };
    };
    tab: {
        extend: string;
        color: string;
        margin: string;
        border: {
            size: string;
            color: string;
            active: {
                color: string;
            };
            hover: {
                color: string;
            };
        };
        hover: {
            color: string;
        };
        active: {
            color: string;
        };
    };
    checkBox: {
        size: string;
        color: string;
        border: {
            color: {
                dark: string;
                light: string;
            };
            width: string;
        };
        check: {
            radius: string;
            thickness: string;
        };
        hover: {
            border: {
                color: {
                    dark: string;
                    light: string;
                };
            };
        };
        toggle: {
            color: {
                dark: string;
                light: string;
            };
            radius: string;
            size: string;
            knob: {};
        };
    };
};
export default _default;
