"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var get_1 = __importDefault(require("lodash/get"));
var isEqual_1 = __importDefault(require("lodash/isEqual"));
var omit_1 = __importDefault(require("lodash/omit"));
var React = __importStar(require("react"));
var react_jsonschema_form_1 = __importDefault(require("react-jsonschema-form"));
var styled_components_1 = __importDefault(require("styled-components"));
var Box_1 = require("../../../components/Box");
var Button_1 = __importDefault(require("../../../components/Button"));
var utils = __importStar(require("../../../utils"));
var DescriptionField_1 = require("./fields/DescriptionField");
var ObjectField_1 = __importDefault(require("./fields/ObjectField"));
var TitleField_1 = require("./fields/TitleField");
var ArrayFieldTemplate_1 = __importDefault(require("./templates/ArrayFieldTemplate"));
var FieldTemplate_1 = __importDefault(require("./templates/FieldTemplate"));
var ObjectFieldTemplate_1 = __importDefault(require("./templates/ObjectFieldTemplate"));
var BaseInput_1 = __importDefault(require("./widgets/BaseInput"));
var PasswordWidget_1 = __importDefault(require("./widgets/PasswordWidget"));
var SelectWidget_1 = __importDefault(require("./widgets/SelectWidget"));
var TextareaWidget_1 = __importDefault(require("./widgets/TextareaWidget"));
var SUPPORTED_SCHEMA_FORMATS = [
    'data-url',
    'date',
    'date-time',
    'email',
    'hostname',
    'ipv4',
    'ipv6',
    'uri',
];
var KEYWORD_BLACKLIST = ['$schema'];
var widgets = {
    BaseInput: BaseInput_1.default,
    SelectWidget: SelectWidget_1.default,
    PasswordWidget: PasswordWidget_1.default,
    TextareaWidget: TextareaWidget_1.default,
};
var fields = {
    DescriptionField: DescriptionField_1.DescriptionField,
    ObjectField: ObjectField_1.default,
    TitleField: TitleField_1.TitleField,
};
var FormWrapper = styled_components_1.default(Box_1.Box)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tsection {\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t\tborder: 0;\n\t}\n\n\t// Style the error list, since it can't be templated\n\t.panel-danger,\n\t.error-detail {\n\t\tfont-size: ", ";\n\t\tmargin-top: ", ";\n\t\tmargin-bottom: ", ";\n\t\tlist-style-type: none;\n\t\tpadding-left: 0;\n\t}\n\n\t.text-danger {\n\t\tcolor: ", ";\n\t}\n"], ["\n\tsection {\n\t\tmargin: 0;\n\t\tpadding: 0;\n\t\tborder: 0;\n\t}\n\n\t// Style the error list, since it can't be templated\n\t.panel-danger,\n\t.error-detail {\n\t\tfont-size: ", ";\n\t\tmargin-top: ", ";\n\t\tmargin-bottom: ", ";\n\t\tlist-style-type: none;\n\t\tpadding-left: 0;\n\t}\n\n\t.text-danger {\n\t\tcolor: ", ";\n\t}\n"])), function (props) { return utils.px(get_1.default(props, 'theme.fontSizes[1]', 14)); }, function (props) { return utils.px(get_1.default(props, 'theme.space[1]', 4)); }, function (props) { return utils.px(get_1.default(props, 'theme.space[1]', 4)); }, function (props) { return get_1.default(props, 'theme.colors.danger.main', '#a94442'); });
var parseSchema = function (schema) {
    var whitelist = SUPPORTED_SCHEMA_FORMATS.concat(Object.keys(widgets));
    return utils.stripSchemaFormats(schema, whitelist);
};
var FormHOC = (function (_super) {
    __extends(FormHOC, _super);
    function FormHOC() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.formRef = React.createRef();
        _this.change = function (data) {
            _this.setState({ value: data.formData });
            if (_this.props.onFormChange) {
                _this.props.onFormChange(data);
            }
        };
        _this.submit = function () {
            if (_this.formRef.current) {
                _this.formRef.current.submit();
            }
        };
        return _this;
    }
    FormHOC.getDerivedStateFromProps = function (props, state) {
        if (!state) {
            return { schema: parseSchema(props.schema), value: props.value };
        }
        if (!isEqual_1.default(state.value, props.value)) {
            return {
                value: props.value,
            };
        }
    };
    FormHOC.registerWidget = function (name, value) {
        widgets[name] = value;
    };
    FormHOC.prototype.componentDidUpdate = function (prevProps) {
        if (!isEqual_1.default(this.props.schema, prevProps.schema)) {
            this.setState({
                schema: parseSchema(this.props.schema),
            });
        }
    };
    FormHOC.prototype.render = function () {
        var _a = this.props, hideSubmitButton = _a.hideSubmitButton, submitButtonText = _a.submitButtonText, submitButtonProps = _a.submitButtonProps, uiSchema = _a.uiSchema, validate = _a.validate, liveValidate = _a.liveValidate, noValidate = _a.noValidate, schema = _a.schema, value = _a.value, onFormChange = _a.onFormChange, onFormSubmit = _a.onFormSubmit, props = __rest(_a, ["hideSubmitButton", "submitButtonText", "submitButtonProps", "uiSchema", "validate", "liveValidate", "noValidate", "schema", "value", "onFormChange", "onFormSubmit"]);
        var localSchema = omit_1.default(utils.disallowAdditionalProperties(this.state.schema), KEYWORD_BLACKLIST);
        return (React.createElement(FormWrapper, __assign({}, props),
            React.createElement(react_jsonschema_form_1.default, { ref: this.formRef, liveValidate: liveValidate, noValidate: noValidate, validate: validate, showErrorList: false, schema: localSchema, formData: this.state.value, onSubmit: this.props.onFormSubmit, onChange: this.props.onFormChange, uiSchema: uiSchema, widgets: widgets, fields: fields, FieldTemplate: FieldTemplate_1.default, ObjectFieldTemplate: ObjectFieldTemplate_1.default, ArrayFieldTemplate: ArrayFieldTemplate_1.default },
                hideSubmitButton && React.createElement("span", null),
                !hideSubmitButton && (React.createElement(Button_1.default, __assign({ primary: true }, submitButtonProps, { type: "submit" }), submitButtonText || 'Submit')))));
    };
    return FormHOC;
}(React.Component));
exports.default = FormHOC;
var templateObject_1;
