import { __assign, __makeTemplateObject } from "tslib";
import Color from 'color';
import * as React from 'react';
import styled from 'styled-components';
import asRendition from '../../asRendition';
import Txt from '../Txt';
var shades = [
    '#B3D2E5',
    '#BAECC2',
    '#FDC7EB',
    '#E5C7EA',
    '#BCE6F5',
    '#FCB9B6',
    '#B6E3DF',
    '#D6D3FA',
    '#C3C7CA',
    '#FBDBB2',
    '#E1E3B9',
    '#DBE0E3',
    '#ffef62',
    '#fbe6f4',
];
var getColors = function (shade) {
    var base = new Color(shade);
    var text = base.darken(0.6).desaturate(0.3);
    return { bg: base.hex(), color: text.hex() };
};
var BaseBadge = styled(Txt.span)(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 1em;\n\tline-height: 1;\n"], ["\n\tfont-family: ", ";\n\tdisplay: inline-block;\n\tborder-radius: 1em;\n\tline-height: 1;\n"])), function (props) { return props.theme.titleFont; });
var Badge = function (_a) {
    var children = _a.children, className = _a.className, shade = _a.shade;
    if (typeof children !== 'string') {
        throw new Error("The child element of the Badge component must be a string, received: " + typeof children);
    }
    var shadeHex = shades[(shade || 0) % shades.length];
    return (React.createElement(BaseBadge, __assign({ className: className, py: 1, px: "12px", fontSize: 0 }, getColors(shadeHex)), children));
};
export default asRendition(Badge);
var templateObject_1;
