import * as React from 'react';
import { Textarea } from '../../../..';
function TextareaWidget(props) {
    var id = props.id, options = props.options, placeholder = props.placeholder, value = props.value, required = props.required, disabled = props.disabled, readonly = props.readonly, autofocus = props.autofocus, onChange = props.onChange, onBlur = props.onBlur, onFocus = props.onFocus;
    return (React.createElement(Textarea, { id: id, className: "form-control", value: typeof value === 'undefined' ? '' : value, placeholder: placeholder, required: required, disabled: disabled, readOnly: readonly, autoFocus: autofocus, rows: options.rows, onBlur: onBlur && (function (event) { return onBlur(id, event.target.value); }), onFocus: onFocus && (function (event) { return onFocus(id, event.target.value); }), onChange: onChange &&
            (function (event) {
                return onChange(event.target.value === '' ? options.emptyValue : event.target.value);
            }) }));
}
export default TextareaWidget;
